// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_LF_MOM_BACKEND/grmi"
	meta "LAPP_LF_MOM_BACKEND/meta/api"
	model "LAPP_LF_MOM_BACKEND/models/api"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : ACCWOWORKORDERDETAILDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : ACCWOWORKORDERDETAIL的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-05-12 14:17:07
 *
 ******************************************************************************/
type ACCWOWORKORDERDETAILDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewACCWOWORKORDERDETAILDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ACCWOWORKORDERDETAILDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *

 * @Return Value             : ACCWOWORKORDERDETAILDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-05-12 14:17:07
 *
 ******************************************************************************/
func NewACCWOWORKORDERDETAILDAOImplement(session *xorm.Session, userid string) *ACCWOWORKORDERDETAILDAOImplement {
	return &ACCWOWORKORDERDETAILDAOImplement{session, &meta.ACCWOWORKORDERDETAIL, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERDETAILDAO.InsertOne
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERDETAILDAOImplement) InsertOne(entity *model.ACCWOWORKORDERDETAIL) error {

	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERDETAILDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERDETAILDAOImplement) DeleteOne(wONO string, uNITSN string) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{wONO, uNITSN}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERDETAILDAO.SelectOne
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERDETAILDAOImplement) SelectOne(wONO string, uNITSN string) (*model.ACCWOWORKORDERDETAIL, error) {
	var data model.ACCWOWORKORDERDETAIL
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{wONO, uNITSN}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERDETAILDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERDETAILDAOImplement) UpdateOne(entity *model.ACCWOWORKORDERDETAIL) error {

	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERDETAILDAO.Insert
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERDETAILDAOImplement) Insert(entities *[]model.ACCWOWORKORDERDETAIL) error {
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERDETAILDAO.Delete
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERDETAILDAOImplement) Delete(entities *[]model.ACCWOWORKORDERDETAIL) error {
	for _, entity := range *entities {

		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERDETAILDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERDETAILDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERDETAILDAO.Select
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERDETAILDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ACCWOWORKORDERDETAIL, error) {

	parameters := []interface{}{}
	where := "1 = 1"

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.ACCWOWORKORDERDETAIL, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERDETAILDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERDETAILDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by "
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.ACCWOWORKORDERDETAIL, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERDETAILDAO.Update
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERDETAILDAOImplement) Update(entities *[]model.ACCWOWORKORDERDETAIL) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]

		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERDETAILDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERDETAILDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.ACCWOWORKORDERDETAIL, columns ...string) error {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := impl.session.Table(impl.meta.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERDETAILDAO.UpdateOneWithPreStatus
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERDETAILDAOImplement) UpdateOneWithPreStatus(entity *model.ACCWOWORKORDERDETAIL, status int) error {
	where := fmt.Sprintf("%s = ? and %s = ? and %s = ?", meta.ACCWOWORKORDERDETAIL_WONO.ColumnName, meta.ACCWOWORKORDERDETAIL_UNITSN.ColumnName, meta.ACCWOWORKORDERDETAIL_STATUS.ColumnName)
	col, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Where(where, entity.WONO, entity.UNITSN, status).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	if col <= 0 {
		return grmi.NewBusinessError("对应的mes SerialOrder数据已更新")
	}
	return nil
}